DROP TABLE IF EXISTS ContactInfo CASCADE;
CREATE TABLE ContactInfo (
	id SERIAL NOT NULL PRIMARY KEY,
	phone VARCHAR(255),
	fax VARCHAR(255),
	mobile VARCHAR(255),
	email VARCHAR(255),
	website VARCHAR(255),
	street1 VARCHAR(255),
	street2 VARCHAR(255),
	zipCode VARCHAR(255),
	city VARCHAR(255),
	state VARCHAR(255),
	country VARCHAR(255),
	envelopeAddress VARCHAR(1000)
);

DROP TABLE IF EXISTS Organisation CASCADE;
CREATE TABLE Organisation (
	id SERIAL NOT NULL PRIMARY KEY,
	organisationName VARCHAR(255),
	departmentName VARCHAR(255),
	contactInfo INTEGER REFERENCES ContactInfo (id)
);

DROP TABLE IF EXISTS ContactPerson CASCADE;
CREATE TABLE ContactPerson (
	id SERIAL NOT NULL PRIMARY KEY,
	title varchar(255),
	firstName varchar(255),
	lastName varchar(255),
	organisation INTEGER REFERENCES Organisation (id),
	remarks varchar(32768),
	contactInfo INTEGER REFERENCES ContactInfo (id)
);

DROP TABLE IF EXISTS SubstanceIdentity CASCADE;
CREATE TABLE SubstanceIdentity (
	id SERIAL NOT NULL PRIMARY KEY,
	bulk BOOLEAN,
	enableMessages BOOLEAN,
	name VARCHAR(255),
	preregister BOOLEAN NOT NULL,
	contactPerson INTEGER REFERENCES ContactPerson (id),
	thirdPartyRepresentative VARCHAR(50),
	registrationDeadline CHAR(10) NOT NULL,
	tonnageBand VARCHAR(10) NOT NULL,
	information VARCHAR(32768)
);

DROP TABLE IF EXISTS Constituent CASCADE;
CREATE TABLE Constituent (
	id SERIAL NOT NULL PRIMARY KEY,
	substanceIdentity INTEGER NOT NULL REFERENCES SubstanceIdentity (id),
	ecNumber CHAR(9),
	casNumber VARCHAR(11),
	casName VARCHAR(2000),
	ecName VARCHAR(2000),
	iupacName VARCHAR(2000),
	otherName VARCHAR(2000),
	lang VARCHAR(2) NOT NULL DEFAULT 'en'
);
