/*
 * SubstanceIdentity.java
 *
 * ECHA is providing program source code to facilitate the preparation of
 * pre-registration XML files. The code shall serve as example and
 * registrants are under no circumstances obliged to make use of this service
 * for submitting data to ECHA. In no event shall ECHA be liable for any
 * damages, direct, incidental or consequential (including through negligence
 * or otherwise) which may result from the use of the data provided, even if
 * ECHA has been advised of the possibility of such damages.
 * The users must assume the entire risk of using this source code.
 */

package eu.europa.echa.reach.preregistration;

import eu.europa.echa.reach.preregistration.xml.XMLWriter;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;

/**
 *
 * @author Csk Gbor
 */
public class SubstanceIdentity {
    public boolean enableMessages;
    public String contactPersonID;
    public String name;
    public String thirdPartyRepresentative;
    public String registrationDeadline;
    public String tonnageBand;
    //similarSubstances // Not implemented
    public String information;
    public List<SubstanceConstituentIdentity> constituents = new LinkedList<SubstanceConstituentIdentity>();
    
    
    public SubstanceIdentity() {
    }
    
    public void serialize(XMLWriter xmlWriter, PreRegistration.Mode mode) throws SerializationException {
        try {
            final String SUBSTANCEIDENTITY = "substanceIdentity";
            xmlWriter.writeComment(name);
            xmlWriter.startElement(XMLWriter.NS.PRG, SUBSTANCEIDENTITY);
            ListIterator<SubstanceConstituentIdentity> iterator = constituents.listIterator();
            while (iterator.hasNext()) {
                iterator.next().serialize(xmlWriter, mode);
            }
            xmlWriter.endElement(XMLWriter.NS.PRG, SUBSTANCEIDENTITY);
        } catch (SAXException ex) {
            throw new SerializationException(ex);
        }
    }
    
}
